package com.lanren.huhu.partner.manager;

import com.lanren.huhu.partner.controller.AgentController;
import com.lanren.huhu.partner.domain.PartnerAccount;
import com.lanren.huhu.partner.model.User;
import com.lanren.huhu.partner.result.Result;
import com.lanren.huhu.partner.service.PartnerAccountService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;

/**
 * @author houseme
 */
@Component
public class UserManager {
    private static Logger logger = LoggerFactory.getLogger(UserManager.class);


    @Autowired
    private PartnerAccountService partnerAccountService;

    /**
     * @description: TODO
     * @param user
     * @return Result<String>
     * @throws
     * @author chen
     * @date 2019-06-26 20:01
     */
    public Result<User> getRelation(User user) {
        setPartnerList(user);
        setAgentList(user);
        Result<User> result = new Result<User>();
        result.setData(user);
        return result;
    }

    /**
     * @description: 找到一个用户邀请关系列表, set到User对象的partnerList中
     * @param user
     * @return void
     * @throws
     * @author chen
     * @date 2019-06-26 20:37
     */
    private void setPartnerList(User user) {
        logger.info("begin setPartnerList for user: {} ......", user.getUserId());
        if (user.getPartnerList() == null) {
            ArrayList<User.ParentPartner> partnerList = new ArrayList<User.ParentPartner>();
            user.setPartnerList(partnerList);
        }
        /**
         * 无限找
         */
        int loopUserId = user.getUserId();
        while (true) {
            logger.info("now loop uid is {}", loopUserId);
            User.ParentPartner parentPartner = getParentPartner(loopUserId);
            if (parentPartner == null) {
                break;
            } else {
                logger.info("parent is {} ", parentPartner.getUserId());
                user.getPartnerList().add(parentPartner);
                loopUserId = parentPartner.getUserId();
            }
            try {
                Thread.sleep(1000L);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        logger.info("setPartnerList for user: {} end", user.getUserId());
    }

    private void setAgentList(User user) {

    }

    private User.ParentPartner getParentPartner(Integer userId) {
        PartnerAccount partnerAccount = partnerAccountService.getParentPartner(userId);
        User.ParentPartner parentPartner = null;
        if (null != partnerAccount) {
            int partnerLevel = partnerAccount.getIsSuperPartner() == 1 ? 30 : partnerAccount.getPartnerLevel();
            parentPartner = new User.ParentPartner(partnerAccount.getUserId(),partnerLevel);
        }
        return parentPartner;
    }
}
